/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SETOR                                                    */
/* Tabela : SETOR                                                             */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SETOR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SETOR
GO

CREATE TRIGGER DTULTATU_SETOR
ON SETOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SETOR', null, 'CDSETOR=' + CDSETOR + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SETOR
      SET DTULTATUSETO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SETOR.CDSETOR,0) = ISNULL(INSERTED.CDSETOR,0)) AND
            (ISNULL(SETOR.SGSETOR,0) = ISNULL(INSERTED.SGSETOR,0)) AND
            (ISNULL(SETOR.NMSETOR,0) = ISNULL(INSERTED.NMSETOR,0));
   END;
END;
GO

